{- levels.p -}

data Rose a = Node a [Rose a];

levels (Node a ts) = [a]:glues (map levels ts);

glues [] = [];
glues (x:xs) = lzw (++) x (glues xs);

map f [] = [];
map f (x:xs) = f x:map f xs;

lzw f [] ys = ys;
lzw f (x:xs) ys = if null ys
                  then x:lzw f xs []
                  else (f x (head ys)) : lzw f xs (tail ys);

null [] = True;
null (x:xs) = False;

head (x:xs) = x;
tail (x:xs) = xs;

TRANSFORM fastlevels
REDEFINE levels t = fastlevels t []
SPECIFYING fastlevels t xs = lzw (++) (levels (foldrose Node (:) [] t)) xs
USING 

DEFINITION levels,glues,map,(++),lzw;

lzwcatassoc: lzw (++) (lzw (++) xss yss) zss = lzw (++) xss (lzw (++) yss zss);

treefusion: f (foldrose node cons nil t) 
            = 
            foldrose node' cons' nil' t, 
            if { f' nil = nil';
                 \ a x -> f' (cons a x) = \a x -> cons' (f a) (f' x);
                 \ b y -> f (node b y)  = \b y -> node' b (f' y) }

END;

foldr f e [] = e;
foldr f e (x:xs) = f x (foldr f e xs);

foldrose node cons nil (Node a ts) 
  = node a (foldr (cons.foldrose node cons nil) nil ts);
